<?php
namespace Planejamento\Repositories;

class Nutrtrab extends \Doctrine\ORM\EntityRepository
{
    /**
     * Verifica produtos a serem zerados pela rotina de ajuste/implantacao de estoque
     *
     * @param $cdfilial
     * @param $cdfilialitlancto
     * @param $dt_lancamento
     * @param $nr_lancamento
     * @param $nrorg
     *
     * @return bool|mixed
     */

    public function calculaNdpcal($nrsequnutr, $cdfilial, $dtreferenc, $cddietnutr, $cdpratoini, $cdpratofim,
                                  $cdpratnutr, $cdservfili){
        $sql = "SELECT
                    SUM(QTPROTLIQU) QTPROTLIQU,
                    SUM(QTPROTEINA) QTPROTTOTAL,
                    (SUM(QTPROTEINA)*4 + SUM(QTALCOOL)*7 + SUM(QTLIPIDEO) * 9 + SUM(QTCARBOIDRATO)*4) VRCALORNUTR, NRSEQPRATNUT
                FROM
                    (SELECT
               NVL(SUM(QTPROTLIQU),0) AS QTPROTLIQU,
               0 QTPROTEINA,
               0 QTALCOOL,
               0 QTLIPIDEO,
               0 QTCARBOIDRATO,
               NRSEQPRATNUT
            FROM
               NUTRTRAB
            WHERE
              (NRSEQUNUTR = :P_NRSEQUNUTR)                          AND
              (CDFILINUTR = :P_CDFILIAL)                            AND
              (CDSERVNUTR = :P_CDSERVFILI)                          AND
              (DTREFENUTR = :P_DTREFERENC)                          AND
              (CDDIETNUTR = 'XXXX' OR CDDIETNUTR = :P_CDDIETNUTR)   AND
              (CDFAPRATNUTR = 'P' OR CDFAPRATNUTR = :P_CDFILIAL)    AND
              ((CDPRATNUTR BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIM)  OR
               (INSTR(:P_CDPRATNUTR, CDPRATNUTR) <> 0))
            GROUP BY NRSEQPRATNUT

            UNION ALL

            SELECT
               0 QTPROTLIQU,
               NVL(SUM(QTNUTRCALC),0) QTPROTEINA,
               0 QTALCOOL,
               0 QTLIPIDEO,
               0 QTCARBOIDRATO,
               NRSEQPRATNUT
            FROM
               NUTRTRAB
            WHERE
              (NRSEQUNUTR = :P_NRSEQUNUTR)                          AND
              (CDFILINUTR = :P_CDFILIAL)                            AND
              (CDSERVNUTR = :P_CDSERVFILI)                          AND
              (DTREFENUTR = :P_DTREFERENC)                          AND
              (CDDIETNUTR = 'XXXX' OR CDDIETNUTR = :P_CDDIETNUTR)   AND
              (CDFAPRATNUTR = 'P' OR CDFAPRATNUTR = :P_CDFILIAL)    AND
              ((CDPRATNUTR BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIM)  OR
               (INSTR(:P_CDPRATNUTR, CDPRATNUTR) <> 0))             AND
              (CDNUTRCALC = (SELECT
                                MAX(CDPROTEINA)
                             FROM
                                PARAMGERAL))
            GROUP BY NRSEQPRATNUT

            UNION ALL

            SELECT
               0 QTPROTLIQU,
               0 QTPROTEINA,
               NVL(SUM(QTNUTRCALC),0) QTALCOOL,
               0 QTLIPIDEO,
               0 QTCARBOIDRATO,
               NRSEQPRATNUT
            FROM
               NUTRTRAB
            WHERE
               (NRSEQUNUTR = :P_NRSEQUNUTR)                          AND
               (CDFILINUTR = :P_CDFILIAL)                            AND
               (CDSERVNUTR = :P_CDSERVFILI)                          AND
               (DTREFENUTR = :P_DTREFERENC)                          AND
               (CDDIETNUTR = 'XXXX' OR CDDIETNUTR = :P_CDDIETNUTR)   AND
               (CDFAPRATNUTR = 'P' OR CDFAPRATNUTR = :P_CDFILIAL)    AND
               ((CDPRATNUTR BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIM)  OR
                (INSTR(:P_CDPRATNUTR, CDPRATNUTR) <> 0))             AND
               (CDNUTRCALC = (SELECT
                                 MAX(CDALCOOL)
                              FROM
                                 PARAMGERAL))
            GROUP BY NRSEQPRATNUT

            UNION ALL

            SELECT
               0 QTPROTLIQU,
               0 QTPROTEINA,
               0 QTALCOOL,
               NVL(SUM(QTNUTRCALC),0) QTLIPIDEO,
               0 QTCARBOIDRATO,
               NRSEQPRATNUT
            FROM
               NUTRTRAB
            WHERE
               (NRSEQUNUTR = :P_NRSEQUNUTR)                          AND
               (CDFILINUTR = :P_CDFILIAL)                            AND
               (CDSERVNUTR = :P_CDSERVFILI)                          AND
               (DTREFENUTR = :P_DTREFERENC)                          AND
               (CDDIETNUTR = 'XXXX' OR CDDIETNUTR = :P_CDDIETNUTR)   AND
               (CDFAPRATNUTR = 'P' OR CDFAPRATNUTR = :P_CDFILIAL)    AND
               ((CDPRATNUTR BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIM)  OR
                (INSTR(:P_CDPRATNUTR, CDPRATNUTR) <> 0))             AND
               (CDNUTRCALC = (SELECT
                                 MAX(CDLIPIDIOS)
                              FROM
                                 PARAMGERAL))
            GROUP BY NRSEQPRATNUT

            UNION ALL

            SELECT
               0 QTPROTLIQU,
               0 QTPROTEINA,
               0 QTALCOOL,
               0 QTLIPIDEO,
               NVL(SUM(QTNUTRCALC),0) QTCARBOIDRATO,
               NRSEQPRATNUT
            FROM
               NUTRTRAB
            WHERE
               (NRSEQUNUTR = :P_NRSEQUNUTR)                          AND
               (CDFILINUTR = :P_CDFILIAL)                            AND
               (CDSERVNUTR = :P_CDSERVFILI)                          AND
               (DTREFENUTR = :P_DTREFERENC)                          AND
               (CDDIETNUTR = 'XXXX' OR CDDIETNUTR = :P_CDDIETNUTR)   AND
               (CDFAPRATNUTR = 'P' OR CDFAPRATNUTR = :P_CDFILIAL)    AND
               ((CDPRATNUTR BETWEEN :P_CDPRATOINI AND :P_CDPRATOFIM)  OR
                (INSTR(:P_CDPRATNUTR, CDPRATNUTR) <> 0))             AND
               (CDNUTRCALC = (SELECT
                                 MAX(CDCARBOHIDRA)
                              FROM
                                 PARAMGERAL))
            GROUP BY NRSEQPRATNUT)
        GROUP BY
           NRSEQPRATNUT";

        $params = array(
            "P_CDFILIAL"   => $cdfilial,
            "P_NRSEQUNUTR" => $nrsequnutr,
            "P_DTREFERENC" => $dtreferenc,
            "P_CDDIETNUTR" => $cddietnutr,
            "P_CDPRATOINI" => $cdpratoini,
            "P_CDPRATOFIM" => $cdpratofim,
            "P_CDPRATNUTR" => $cdpratnutr,
            "P_CDSERVFILI" => $cdservfili
        );

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);

        return count($result)>0 ? $result[0] : false;
    }
}